﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
' REL 22/10/2021
#Event: ItemClick (Position As Int, CheckValue As Boolean)

#DesignerProperty: Key: Corner, DisplayName: Rounded Corner, FieldType: Int, DefaultValue: 0, MinRange: 0, MaxRange: 50, Description: Rounded corner
#DesignerProperty: Key: CornerColor, DisplayName: CornerColor Color, FieldType: Color, DefaultValue: 0xFF000000, Description: CornerColor color
#DesignerProperty: Key: Background, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color
#DesignerProperty: Key: Style, DisplayName: View Style, FieldType: String, DefaultValue: Frame, List: Frame|Bead
#DesignerProperty: Key: Opening, DisplayName: Opening, FieldType: String, DefaultValue: Frame, List: Automatic|Top|Bottom

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Private outListPanel As B4XView
	Private ListPanel As B4XView
	Private ListItem As List
	
	Private Corner As Int
	Private Style As String = "Frame"
	Private TextColor As Int 
	Private BClr As Int
	Private LabelHint As B4XView
	Private Scroll As B4XView
	Private PanelScroll As B4XView
	Private CornerColor As Int
	Private TF as B4XFont

	Public Opening As String = "Automatic"
	Public ItemHeight As Int
	Public ItemWidth As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	outListPanel=xui.CreatePanel("outListPanel")
	#If B4A
	Dim Sc As ScrollView
	Sc.Initialize2(1000dip,"Sc")
	ListPanel=Sc
	#Else IF B4i
	Dim Sc As ScrollView
	Sc.Initialize("Sc",500dip,100dip)
	ListPanel=Sc
	#Else if B4j
	Dim Sc As ScrollPane
	Sc.Initialize("Sc")
	Sc.SetHScrollVisibility("NEVER")
	Sc.SetVScrollVisibility("NEVER")
	ListPanel=Sc
	#End If
	
	ListItem.Initialize
	
	CreateHorizzontalScroll
	
	ItemHeight=40dip
	ItemWidth=100dip
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	
	If Props.ContainsKey("Style") Then Style=Props.Get("Style")
	If Props.ContainsKey("Opening") Then Opening=Props.Get("Opening")
	If Props.ContainsKey("CornerColor") Then CornerColor=xui.PaintOrColorToColor(Props.Get("CornerColor")) 
	If Props.ContainsKey("Background") Then	BClr=xui.PaintOrColorToColor(Props.Get("Background")) Else BClr=mBase.Color
	Corner=Props.Get("Corner")
	Corner=Corner*(100dip/100)
	
	#IF B4J
	mBase.As(Pane).Style="-fx-border-radius:0.00;-fx-background-radius:0.00;-fx-border-width:0.00;"
	#ELSE IF B4i
	ListPanel.As(ScrollView).Bounces=False
	#End If
	
	TextColor=Lbl.As(B4XView).TextColor

	LabelHint=CreateLabel("MyLabel")
	LabelHint.Text=Chr(0xF006) 'lbx.EditTextHint
	LabelHint.TextColor=TextColor
	LabelHint.Color=xui.Color_Transparent
	LabelHint.SetTextAlignment("CENTER","CENTER")
	LabelHint.Font=xui.CreateFontAwesome(Lbl.As(B4XView).Font.Size)
	TF=Lbl.As(B4XView).Font

	Select Style
		Case "Frame"
			mBase.SetColorAndBorder(BClr,1dip,CornerColor,Corner)
		Case "Bead"
			LabelHint.TextColor=BClr
			LabelHint.SetColorAndBorder(CornerColor,0dip,xui.Color_Transparent,20dip)
			
			Dim Can As B4XCanvas
			Dim Rec As B4XRect
			
			Can.Initialize(mBase)
			Rec.Initialize(20dip,mBase.Height/2,mBase.Width-20dip,mBase.Height)
			Can.DrawRect(Rec,CornerColor,True,0dip)
			Dim Rec As B4XRect
			Rec.Initialize(45dip,0dip,mBase.Width,mBase.Height-1dip)
			Dim Path As B4XPath
			Path.InitializeRoundedRect(Rec,20dip)
			Can.DrawPath(Path,BClr,True,0dip)
			Can.Invalidate
		
	End Select

	mBase.AddView(LabelHint,5dip,0dip,40dip,mBase.Height)
	mBase.AddView(Scroll,50dip,2dip,mBase.Width-51dip,mBase.Height-6dip)
	Scroll_SetPanelHeight(mBase.Height-7dip)
	
	Scroll_setColor(xui.Color_Transparent)
	
	#IF B4A
	Dim Pevent As TouchPanelCreator
	mBase.AddView(Pevent.CreateTouchPanel("MyLabel"),0dip,0dip,mBase.Width,mBase.Height)
	#End If
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	Scroll.Width=Width-50dip
	Scroll.Height=Height-5dip
	Scroll_SetPanelHeight(Height-6dip)
	LabelHint.Height=Height
	
	#IF B4I
	ListPanel.As(ScrollView).ContentWidth=mBase.Width-3dip
	#end if
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub


 #Region Method
 
Public Sub setHint(Text As String)
	LabelHint.Text=Text
End Sub

Public Sub getHint As String
	Return LabelHint.Text
End Sub

Public Sub setHintFont(Fnt As B4XFont)
	LabelHint.Font=Fnt
End Sub

Public Sub getHintFont As B4XFont
	Return LabelHint.Font
End Sub

Public Sub setTextFont(Fnt As B4XFont)
	TF=Fnt
	RefreshSelected
End Sub

Public Sub getTextFont As B4XFont
	Return TF
End Sub
 
 ' ----------------------------------------- METHOD COMBO ---------------------------
 
' Add Item
Public Sub Add(Text As String, ReturnValue As Object, Check As Boolean)
	Dim M As Map
	M.Initialize
	M.Put("Text",Text)
	M.Put("Value",ReturnValue)
	M.Put("object",Null)
	M.Put("check",Check)
	M.Put("Enabled",True)
	
	ListItem.Add(M)
	RefreshSelected
End Sub

Public Sub Add2(Text As String, ReturnValue As Object, Check As Boolean, Enabled As Boolean)
	Dim M As Map
	M.Initialize
	M.Put("Text",Text)
	M.Put("Value",ReturnValue)
	M.Put("object",Null)
	M.Put("check",Check)
	M.Put("Enabled",Enabled)
	
	ListItem.Add(M)
	RefreshSelected
End Sub

' Add List of Item, Return Value is a Text
Public Sub AddAll(L As List)
	For Each text As String In L
		Dim M As Map
		M.Initialize
		M.Put("Text",text)
		M.Put("Value",text)
		M.Put("object",Null)
		M.Put("check",False)
		M.Put("Enabled",True)
		
		ListItem.Add(M)
		RefreshSelected
	Next
End Sub
 
public Sub Size As Int
	Return ListItem.Size
End Sub

Public Sub Clear
	ListItem.Clear
End Sub

Public Sub OpenDropDown
	fixPanel
	DrawListBox
End Sub

Public Sub CloseDropDown
	outListPanel.RemoveViewFromParent
End Sub

Public Sub isDroprDownOpen As Boolean
	Return Not(outListPanel.Parent=Null)
End Sub

Public Sub RemoveIndex(Position As Int)
	If Position>-1 And Position<ListItem.Size Then ListItem.RemoveAt(Position)
End Sub

Public Sub GetText(Position As Int) As String
	Dim Ret As String 

	If Position>-1 And Position<ListItem.Size Then
		Ret=ListItem.Get(Position).As(Map).Get("Text")
	End If
	Return Ret
End Sub

Public Sub GetReturnValue(Position As Int) As Object
	Dim Ret As Object
	If Position>-1 And Position<ListItem.Size Then
		Ret=ListItem.Get(Position).As(Map).Get("Value")
	End If
	
	Return Ret
End Sub

Public Sub GetChecked(Position As Int) As Boolean
	Dim Ret As Boolean = False
	If Position>-1 And Position<ListItem.Size Then
		Ret=ListItem.Get(Position).As(Map).Get("check")
	End If
	
	Return Ret
End Sub

Public Sub SetChecked(Position As Int,Check As Boolean)
	If Position>-1 And Position<ListItem.Size Then
		ListItem.Get(Position).As(Map).put("check",Check)
		Dim Ch As B4XView = ListItem.Get(Position).As(Map).Get("object")
		If Ch.IsInitialized Then Ch.Checked=Check
		RefreshSelected
	End If
End Sub

Public Sub SetEnabled(Position As Int,Check As Boolean)
	If Position>-1 And Position<ListItem.Size Then
		ListItem.Get(Position).As(Map).put("Enabled",Check)
		Dim Ch As B4XView = ListItem.Get(Position).As(Map).Get("object")
		If Ch.IsInitialized Then Ch.Enabled=Check
		RefreshSelected
	End If
End Sub

' xMultiSpinner1.SelectedToText("") --> One,Two,Three
' xMultiSpinner1.SelectedToText(chr(34)) --> "One","Two","Three"
' xMultiSpinner1.SelectedToText("'") --> 'One','Two','Three'
Public Sub SelectedToText(CharEnclose As String) As String
	Dim S As String = ""
	
	For i=0 To ListItem.Size-1
		If  ListItem.Get(i).As(Map).Get("check").As(Boolean) Then S = S & CharEnclose &  ListItem.Get(i).As(Map).Get("Text") & CharEnclose & ","
	Next
	If S.Length>1 Then S=S.SubString2(0,S.Length-1)
	
	Return S
End Sub

' xMultiSpinner1.SelectedReturnValueToText("") --> ValueOne,ValueTwo,ValueThree
' xMultiSpinner1.SelectedReturnValueToText(chr(34)) --> "ValueOne","ValueTwo","ValueThree"
' xMultiSpinner1.SelectedReturnValueToText("'") --> 'ValueOne','ValueTwo','ValueThree'
Public Sub SelectedReturnValueToText(CharEnclose As String) As String
	Dim S As String = ""
	
	For i=0 To ListItem.Size-1
		If  ListItem.Get(i).As(Map).Get("check").As(Boolean) Then S = S & CharEnclose & ListItem.Get(i).As(Map).Get("Value") & CharEnclose & ","
	Next
	If S.Length>1 Then S=S.SubString2(0,S.Length-1)
	
	Return S
End Sub

Public Sub SelectedTextToArray As String()
	Dim L As List
	
	L.Initialize
	For i=0 To ListItem.Size-1
		If  ListItem.Get(i).As(Map).Get("check").As(Boolean) Then L.Add(ListItem.Get(i).As(Map).Get("Text").As(String))
	Next
	
	If L.Size>0 Then
		Dim Rt(l.Size) As String
		
		For i=0 To l.Size-1
			Rt(i)=L.Get(i)
		Next
		Return Rt
	Else
		Return Array As String()
	End If
End Sub

Public Sub SelectedReturnValueToArray As Object()
	Dim L As List
	
	L.Initialize
	For i=0 To ListItem.Size-1
		If  ListItem.Get(i).As(Map).Get("check").As(Boolean) Then L.Add(ListItem.Get(i).As(Map).Get("Text").As(Object))
	Next
	
	If L.Size>0 Then
		Dim Rt(l.Size) As Object
		
		For i=0 To l.Size-1
			Rt(i)=L.Get(i)
		Next
		Return Rt
	Else
		Return Array As Object()
	End If
End Sub

Public Sub SelectedIndexToArray As Int()
	Dim L As List
	
	L.Initialize
	For i=0 To ListItem.Size-1
		If  ListItem.Get(i).As(Map).Get("check").As(Boolean) Then L.Add(I)
	Next
	
	If L.Size>0 Then
		Dim Rt(l.Size) As Int
		
		For i=0 To l.Size-1
			Rt(i)=L.Get(i)
		Next
		Return Rt
	Else
		Return Array As Int()
	End If
End Sub

#end region

#Region Event

Private Sub outListPanel_Click
	CloseDropDown
End Sub

Private Sub CheckSelect_ValueChanged (Value As Boolean)
	' B4I
	Dim ch As B4XView = Sender
	Dim index As Int = ch.Tag
	
	ListItem.Get(index).As(Map).put("check",Value)
	RefreshSelected
	If xui.SubExists(mCallBack,mEventName & "_ItemClick",2) Then
		CallSubDelayed3(mCallBack,mEventName & "_ItemClick",index,GetChecked(index))
	End If
End Sub

Private Sub CheckSelect_CheckedChange(Checked As Boolean)
	' B4J e B4A
	Dim ch As B4XView = Sender
	If IsNumber(ch.tag) Then 
		Dim index As Int = ch.Tag
		
		ListItem.Get(index).As(Map).put("check",Checked)
		RefreshSelected
		If xui.SubExists(mCallBack,mEventName & "_ItemClick",2) Then
			CallSubDelayed3(mCallBack,mEventName & "_ItemClick",index,GetChecked(index))
		End If
	End If
End Sub

Private Sub LabSelect_Click
	Dim L As B4XView = Sender
	Dim index As Int = L.Tag
	
	Sleep(100)
	If xui.SubExists(mCallBack,mEventName & "_ItemClick",2) Then 
		CallSubDelayed3(mCallBack,mEventName & "_ItemClick",index,GetReturnValue(index))
	End If
	outListPanel.RemoveViewFromParent
End Sub

Private Sub MyLabel_Click
	OpenDropDown
End Sub

Private Sub MyLabel_FocusChanged (HasFocus As Boolean)
	If HasFocus Then 
		OpenDropDown 
	End If
End Sub


#IF B4J

Private Sub outListPanel_MouseClicked (EventData As MouseEvent)
	outListPanel_Click
End Sub

Private Sub Mylabel_MouseClicked (EventData As MouseEvent)
	MyLabel_Click
End Sub

Private Sub ColorToHex(clr As Long) As String
	Dim r,g,b,a As Byte
	b=Bit.And(clr,0x000000FF) 'b
	g=Bit.ShiftRight(Bit.And(clr,0x0000FF00),8) 'g
	r=Bit.ShiftRight(Bit.And(clr,0x00FF0000),16) ' r
	a=Bit.ShiftRight(Bit.And(clr,0xFF000000),24) 'a
	
	
	Return Byte2Hex(r) & Byte2Hex(g) & Byte2Hex(b) & Byte2Hex(a)
End Sub

Private Sub Byte2Hex(b As Int) As String
	Dim hex As String = "0123456789ABCDEF"
	Dim l,h As Int
	l=Bit.And(b,0xf)
	h=Bit.And(Bit.ShiftRight(b,4),0xf)      ' <- safety fix
	Return (hex.CharAt(h) & hex.CharAt(l))
End Sub

#End If

#End Region

#Region function

Private Sub fixPanel
	Try
		Dim Left As Int = mBase.Left
		Dim Top As Int = mBase.top
		Dim prec As B4XView = mBase
		Dim pnl As B4XView = mBase.Parent
		
		Do While (pnl.Parent.IsInitialized) And (GetType(pnl)<>"B4IMainView")
			'Log(GetType(pnl))
			Left=Left+pnl.Left
			Top=Top+pnl.Top
			prec=pnl
			pnl=pnl.Parent
		Loop
	Catch
		Log(LastException.Message)
	End Try
	If xui.IsB4i Then pnl=prec
	
	outListPanel.Color=xui.Color_ARGB(50,50,50,50)
	outListPanel.RemoveViewFromParent
	pnl.AddView(outListPanel,0,0,pnl.Width,pnl.Height)
	
	ListPanel.RemoveViewFromParent
	
	Dim Opn As String = Opening
	If Opening="Automatic" Then Opn=IIf(Top+(mBase.Height/2)>outListPanel.Height/2,"Top","Bottom")
		
	If Opn="Top" Then 
		' UP List
		outListPanel.AddView(ListPanel,Left,0,mBase.Width,Top)
	Else
		' down list
		outListPanel.AddView(ListPanel,Left,Top+mBase.Height,mBase.Width,outListPanel.Height-Top-mBase.Height)
	End If
End Sub

Private Sub DrawListBox
	Dim Height As Int = 0
	
	#if B4A or B4i
		ListPanel.As(ScrollView).Panel.RemoveAllViews
		ListPanel.Color=TextColor
	#ELSE If B4J
		ListPanel.As(ScrollPane).InnerNode.As(Pane).RemoveAllNodes
		ListPanel.As(ScrollPane).Style="-fx-background:#" & ColorToHex(CornerColor) & ";-fx-background-color:#" & ColorToHex(CornerColor) & ";"
	#End If
	
	For i=0 To ListItem.Size-1
		Dim v As Map = ListItem.Get(i)
		Dim ch As B4XView = CreateCheck("CheckSelect")
		ch.Color=BClr
		ch.TextColor=TextColor
		ch.Text=v.Get("Text")
		ch.Tag=i
		ch.Checked=v.Get("check")
		ch.Enabled=v.Get("Enabled")
		v.Put("object",ch)

		#if B4A
			ListPanel.As(ScrollView).Panel.AddView(ch,2dip,Height,ListPanel.Width-2dip,ItemHeight-3dip)
		#ELSE If B4I
			ListPanel.As(ScrollView).Panel.AddView(ch,2dip,Height,ListPanel.Width-2dip,ItemHeight-3dip)
			Dim L As B4XView = CreateLabel("")
			L.Color=BClr
			L.TextColor=TextColor
			L.Text=v.Get("Text")
			ListPanel.As(ScrollView).Panel.AddView(l,57dip,Height,ListPanel.Width-60dip,ItemHeight-3dip)
		#ELSE If B4J
			ListPanel.As(ScrollPane).InnerNode.As(Pane).AddNode(ch,2dip,Height,ListPanel.Width,ItemHeight-3dip)
		#End If
		
		Height=Height+ItemHeight
	Next
	
	#if B4A or B4I
		ListPanel.As(ScrollView).Panel.Height=Height
	#ELSE If B4J
		ListPanel.As(ScrollPane).InnerNode.As(Pane).PrefHeight=Height
	#End If
	
	ListPanel.ScrollViewContentHeight=Height
	If Height<ListPanel.Height Then ListPanel.Height=Height
End Sub

Private Sub RefreshSelected
	Dim Left As Int = 5dip
	Scroll_RemoveAllViews
	Scroll_SetPanelWidth(Left)
	For i=0 To ListItem.Size-1
		Dim v As Map = ListItem.Get(i)
			If v.Get("check").As(Boolean) Then 
				Dim Lb As B4XView = CreateLabel("MyLabel")
				Lb.SetColorAndBorder(CornerColor,0dip,xui.Color_White,Scroll.Height/2)
				Lb.TextColor=BClr
				Lb.Text=v.Get("Text")
				Lb.Font=TF
				Lb.SetTextAlignment("CENTER","CENTER")
				Scroll_AddView(Lb,Left,0dip,ItemWidth,Scroll.Height-2dip)
				Left= Left + ItemWidth + 5dip
			End If
	Next

End Sub

Private Sub CreateLabel(EventName As String) As B4XView
	Dim L As Label
	L.Initialize(EventName)
	Return L
End Sub

Private Sub CreateCheck(EventName As String) As B4XView
	#If B4A or B4J
	Dim C As CheckBox
	C.Initialize(EventName)
	Return C
	#ELSE IF B4i
	Dim S As Switch
	S.Initialize(EventName)
	Return s
	#End If
End Sub

#End Region

#region Horizzonal Scroll

Private Sub CreateHorizzontalScroll
	#IF B4I
		Private sc As ScrollView
		sc.Initialize("MyLabel",1000dip,1000dip)
		PanelScroll=sc.Panel
	#ELSE IF B4J
		Private sc As ScrollPane
		sc.Initialize("MyLabel")
		sc.Style="-fx-background:transparent;-fx-background-color:transparent;"
		PanelScroll=sc.InnerNode
		sc.Pannable=True
	#ELSE IF B4a
		Private sc As HorizontalScrollView
		sc.Initialize(1000dip,"MyLabel")
		PanelScroll=sc.Panel
	#END IF
	Scroll = sc
	Scroll.Color=xui.Color_White
	Scroll_setVerticalBar(False)
	Scroll_setHorizontalBar(False)
End Sub

Private Sub Scroll_GetPanelWidth As Int
	#IF B4i
		Return Scroll.As(ScrollView).ContentWidth
	#ELSE IF B4J
		Return Scroll.As(ScrollPane).InnerNode.PrefWidth
	#else IF B4A
		Return Scroll.As(HorizontalScrollView).Panel.Width
	#End If
End Sub

Private Sub Scroll_SetPanelWidth(W As Int)
	PanelScroll.Width=W
	#IF B4i
		Scroll.As(ScrollView).ContentWidth=w
	#ELSE IF B4J
		Scroll.As(ScrollPane).InnerNode.PrefWidth=w
	#else IF B4A
		Scroll.As(HorizontalScrollView).Panel.Width=w
	#End If
End Sub

Private Sub Scroll_GetPanelHeight As Int
	#IF B4i
		Return Scroll.As(ScrollView).ContentHeight
	#ELSE IF B4J
		Return Scroll.As(ScrollPane).InnerNode.PrefHeight
	#else IF B4A
		Return Scroll.As(HorizontalScrollView).Panel.Height
	#End If
End Sub

Private Sub Scroll_SetPanelHeight(H As Int)
	PanelScroll.Height=H
	#IF B4i
		Scroll.As(ScrollView).ContentHeight=h
	#ELSE IF B4J
		Scroll.As(ScrollPane).InnerNode.PrefHeight=h
	#else IF B4A
		Scroll.As(HorizontalScrollView).Panel.Height=h
	#End If
End Sub

Private Sub Scroll_AddView(View As B4XView, Left As Int, Top As Int, Width As Int, Height As Int)
	PanelScroll.AddView(View,Left,Top,Width,Height)
	Scroll_SetPanelWidth(Left+Width)
End Sub

Private Sub Scroll_setColor(c As Int)
	#IF B4j
	If c=xui.Color_Transparent Then 
		Scroll.As(ScrollPane).Style="-fx-background:transparent;-fx-background-color:transparent;"
	Else
		Scroll.As(ScrollPane).Style="-fx-background:#" & ColorToHex(c) & ";-fx-background-color:#" & ColorToHex(c) & ";"
	End If
	#ELSE
		PanelScroll.Color=c
	#END IF
End Sub

Private Sub Scroll_RemoveAllViews
	PanelScroll.RemoveAllViews
End Sub

Private Sub Scroll_setHorizontalBar(B As Boolean)
	#IF B4i
		Scroll.As(ScrollView).ShowsHorizontalIndicator=B
	#Else if B4A
		Dim r As Reflector
		r.Target = Scroll.As(HorizontalScrollView)
		r.RunMethod2("setHorizontalScrollBarEnabled", B, "java.lang.boolean")
	#else B4J
		If B Then Scroll.As(ScrollPane).SetHScrollVisibility("AS_NEEDED") Else Scroll.As(ScrollPane).SetHScrollVisibility("NEVER")
	#End If
End Sub

Private Sub Scroll_setVerticalBar(B As Boolean)
	#IF B4i
		Scroll.As(ScrollView).ShowsVerticalIndicator=B
	#Else if B4A
		Dim r As Reflector
		r.Target = Scroll.As(HorizontalScrollView)
   		r.RunMethod2("setVerticalScrollBarEnabled", False, "java.lang.boolean")		
	#else B4J
		If B Then Scroll.As(ScrollPane).SetVScrollVisibility("AS_NEEDED") Else Scroll.As(ScrollPane).SetVScrollVisibility("NEVER")
	#End If	
End Sub

#End Region

#if B4a
Private Sub MyLabel_OnInterceptTouchEvent (Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	OpenDropDown
	Return False
End Sub
#End If